Imports System.IO
Imports Windows.ApplicationModel
Imports Windows.ApplicationModel.Activation
Imports Windows.Foundation
Imports Windows.Foundation.Collections
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Controls
Imports Windows.UI.Xaml.Controls.Primitives
Imports Windows.UI.Xaml.Data
Imports Windows.UI.Xaml.Input
Imports Windows.UI.Xaml.Media
Imports Windows.UI.Xaml.Navigation

' The Blank Application template is documented at http://go.microsoft.com/fwlink/?LinkId=234227

''' <summary>
''' Provides application-specific behavior to supplement the default Application class.
''' </summary>
Partial Public NotInheritable Class App
    Inherits Application

    ''' <summary>
    ''' Initializes the singleton application object.  This is the first line of authored code
    ''' executed, and as such is the logical equivalent of main() or WinMain.
    ''' </summary>
    Public Sub New()
        Me.InitializeComponent()
        AddHandler Me.Suspending, AddressOf OnSuspending
    End Sub

    ''' <summary>
    ''' Invoked when the application is launched normally by the end user.  Other entry points
    ''' will be used when the application is launched to open a specific file, to display
    ''' search results, and so forth.
    ''' </summary>
    ''' <param name="args">Details about the launch request and process.</param>
    Protected Overrides Sub OnLaunched(ByVal args As LaunchActivatedEventArgs)
        ' Do not repeat app initialization when already running, just ensure that
        ' the window is active
        If args.PreviousExecutionState = ApplicationExecutionState.Running Then
            Window.Current.Activate()
            Exit Sub
        End If

        If args.PreviousExecutionState = ApplicationExecutionState.Terminated Then
            'TODO: Load state from previously suspended application
        End If

        ' Create a Frame to act navigation context and navigate to the first page
        Dim rootFrame As Frame = New Frame
        If Not rootFrame.Navigate(GetType(MainPage)) Then
            Throw New Exception("Failed to create initial page")
        End If

        ' Place the frame in the current Window and ensure that it is active
        Window.Current.Content = rootFrame
        Window.Current.Activate()
    End Sub

    ''' <summary>
    ''' Invoked when application execution is being suspended.  Application state is saved
    ''' without knowing whether the application will be terminated or resumed with the contents
    ''' of memory still intact.
    ''' </summary>
    ''' <param name="sender">The source of the suspend request.</param>
    ''' <param name="e">Details about the suspend request.</param>
    Private Sub OnSuspending(ByVal sender As Object, ByVal e As SuspendingEventArgs)
        Dim deferral As SuspendingDeferral = e.SuspendingOperation.GetDeferral
        'TODO: Save application state and stop any background activity
        deferral.Complete()
    End Sub
End Class
